#include <intrins.h>
#include "TP.h"
#include "delay.h"
#include "UserDef.h"
#include "RA8889_51.h"
#include "RA8889_MCU_IF.h"
#include "RA8889_API_51.h"	 

unsigned char   Touch_State=0;


#if CTP	   //  Capacitive touch screen
  

//Touch Status	 
#define Key_Down 0x01
#define Key_Up   0x00 


struct _ts_event
{
    uint    x1;
    uint    y1;
    uint    x2;
    uint    y2;
    uint    x3;
    uint    y3;
    uint    x4;
    uint    y4;
    uint    x5;
    uint    y5;
	
    uchar     touch_point;
};

struct _ts_event ts_event; 

#define WRITE_ADD	0xba 
#define READ_ADD	0xbb

#define CT_MAX_TOUCH    5		//ݴֵ֧ĵ

// Registers define
#define GTP_READ_COOR_ADDR    0x814e
#define GTP_REG_SLEEP         0x8040
#define GTP_REG_SENSOR_ID     0x814a
#define GTP_REG_CONFIG_DATA   0x8047
#define GTP_REG_VERSION       0x8440

//#define CT_READ_XY_REG 	0x814E  	//ȡĴ 
//#define CT_CONFIG_REG   0x8047	//òʼĴ

 uchar code GTP_CFG_DATA[]=
{

0x5A,0x20,0x03,0x58,0x02,0x05,0x0D,0x00,
0x01,0x0A,0x28,0x0F,0x50,0x32,0x03,0x05,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x8C,0x2E,0x0E,0x3C,0x3E,
0xD3,0x07,0x00,0x00,0x01,0x00,0x03,0x1D,
0x00,0x01,0x00,0x00,0x00,0x03,0x64,0x32,
0x00,0x00,0x00,0x32,0x82,0x94,0xC5,0x02,
0x08,0x00,0x00,0x04,0x8A,0x37,0x00,0x75,
0x42,0x00,0x62,0x50,0x00,0x52,0x62,0x00,
0x46,0x76,0x00,0x46,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,0x10,
0x12,0x14,0x16,0x18,0x1A,0x1C,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,
0x04,0x06,0x08,0x0A,0x0C,0x0F,0x10,0x12,
0x13,0x14,0x16,0x18,0x1C,0x1D,0x1E,0x1F,
0x20,0x21,0x22,0x24,0x26,0x28,0x29,0x2A,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x59,0x01
					

};



//IIC start
void TOUCH_Start(void)
{ 
	SDA1=1;  
	delay_us(3);
	SCL=1;
	delay_us(3);
	SDA1=0;  
	delay_us(3);
	SCL=0;
//	delay_us(1);
}	  


//IIC stop
void TOUCH_Stop(void)
{
	SDA1=0;
	delay_us(3);
	SCL=1;
	delay_us(3);
	SDA1=1;
	delay_us(3);
	SCL=0;
//	delay_us(1);						   	
}


//Acknowledge
void TOUCH_Ack(void)
{	SCL=0;
	_nop_();
	SDA1=0;
	delay_us(3);
	SCL=1;
	delay_us(3);
	SCL=0;
	_nop_();
}



//NO Acknowledge		    
void TOUCH_NAck(void)
{	SCL=0;
	delay_us(3);
	SDA1=1;
	delay_us(3);
	SCL=1;
	delay_us(3);
	SCL=0;
	_nop_();
}	
	

//IIC send one byte		  
uchar TOUCH_Send_Byte(uchar Byte)
{	uchar t;  	uchar errtime=0;		
 	SCL=0; 
//	delayus(5);
    for(t=0;t<8;t++)
    {           
	   	SDA1=(bit)(Byte & 0x80) ;
	   	Byte <<=1;
		delay_us(3);
	   	SCL=1;
		delay_us(3);
	   	SCL=0;
	//	delayus(5);
    }
	


	SDA1=1;
	delay_us(1);
	SCL=1;
	delay_us(1);
  	while(SDA1)		 //wait ACK
	{
	    errtime++;
	    if(errtime>250)
		    {
		      TOUCH_Stop();
		      return 1;
		    }	
	   ;  
	}
	SCL=0;	
		
 return 0;
} 

//Read one byteack=0Send Acknowledgeack=1NO Acknowledge   
uchar TOUCH_Read_Byte(uchar ack)
{	uchar t,receive=0;

	SCL=0;
//	delayus(5);
	SDA1=1;
//	delayus(5);
	for(t = 0; t < 8; t++)
	{	_nop_();
	 	SCL = 0;
		delay_us(4);
	 	SCL=1;
		delay_us(4);
	 	receive<<=1;
	 	if(SDA1)receive=receive|0x01;
	//	delayus(5);
	}

					 
   	if (ack)  TOUCH_NAck();//NO Acknowledge 
   	else       TOUCH_Ack(); //Send Acknowledge   
    
	 return receive;
}

uchar GT911_WR_Reg(uint reg,uchar *buf,uchar len)
{
	uchar i;
	uchar ret=0;
	TOUCH_Start();	
 	ret=TOUCH_Send_Byte(WRITE_ADD);   	//д 	 
	 if(ret)return ret; 
	ret=TOUCH_Send_Byte(reg>>8);   	//͸8λַ
	 if(ret)return ret; 										  		   
	ret=TOUCH_Send_Byte(reg&0XFF);   	//͵8λַ
	if(ret)return ret; 
	for(i=0;i<len;i++)
	{	   
    	ret=TOUCH_Send_Byte(buf[i]);  	//		
		if(ret)return ret;  
	}
    TOUCH_Stop();					//һֹͣ	    
	return 0; 
}


uchar GT911_RD_Reg(uint reg,uchar *buf,uchar len)
{	uchar ret=0;
	uchar i;
 	TOUCH_Start();	
 	ret=TOUCH_Send_Byte(WRITE_ADD);   	//д 	 
	if(ret)return ret; 
 	ret=TOUCH_Send_Byte(reg>>8);   	//͸8λַ
  	if(ret)return ret; 									  		   
 	ret=TOUCH_Send_Byte(reg&0XFF);   	//͵8λַ
	if(ret)return ret; 
  
 	TOUCH_Start(); 	 	   
	ret=TOUCH_Send_Byte(READ_ADD);    //Ͷ		   
  	if(ret)return ret; 
	for(i=0;i<len;i++)
	{	   
    	buf[i]=TOUCH_Read_Byte(i==(len-1)?1:0); //
		
		
	//	if(i==(len-1))  buf[i]=TOUCH_Read_Byte(1);
	//	else            buf[i]=TOUCH_Read_Byte(0);	 
		
	} 
     TOUCH_Stop();//һֹͣ
	return 0; 	 	    
}

uchar GT911_Send_Cfg(uchar * buf,uint cfg_len)
{
	uchar ret=0;
	uchar retry=0;
	for(retry=0;retry<2;retry++)
	{
		ret=GT911_WR_Reg(GTP_REG_CONFIG_DATA,buf,cfg_len);
		if(ret)return ret;
		delay_ms(10);	 
	}
	return 0;
}



uchar GT911_read_data(void)
{	uchar buf[40] = {0xff}; uchar ret = 0;	uchar ss[4];


	GT911_RD_Reg(GTP_READ_COOR_ADDR,buf,40);		

	ss[0]=0;		
 	GT911_WR_Reg(GTP_READ_COOR_ADDR,ss,1);	  //Must clear  Buffer status
  
  	ts_event.touch_point = buf[0] & 0x0f;

 

  	if (ts_event.touch_point == 0) 
		{  			

			return 0;
  		}		
   

					switch (ts_event.touch_point) 
					{
							case 5:
				           			ts_event.x5 = (uint)(buf[35] )<<8 | (uint)buf[34];
				           			ts_event.y5 = (uint)(buf[37] )<<8 | (uint)buf[36];
				
						    case 4:
						           	ts_event.x4 = (uint)(buf[27] )<<8 | (uint)buf[26];
						           	ts_event.y4 = (uint)(buf[29] )<<8 | (uint)buf[28];
						
						    case 3:
						           	ts_event.x3 = (uint)(buf[19] )<<8 | (uint)buf[18];
						           	ts_event.y3 = (uint)(buf[21] )<<8 | (uint)buf[20];
						
						    case 2:
						           	ts_event.x2 = (uint)(buf[11] )<<8 | (uint)buf[10];
						           	ts_event.y2 = (uint)(buf[13] )<<8 | (uint)buf[12];
						
						    case 1:
						           	ts_event.x1 = (uint)(buf[3] )<<8 | (uint)buf[2];
						           	ts_event.y1 = (uint)(buf[5] )<<8 | (uint)buf[4];
				
				    break;
						    default:
						    return 0;
					}


	   
	return 0;
}


void inttostr(uint value,uchar *str)
{
	str[0]=value/1000+48;
	str[1]=value%1000/100+48;
	str[2]=value%1000%100/10+48;
 	str[3]=value%1000%100%10+48;
}


uchar TOUCH_Init(void)
{uchar ss[5];
	uchar ret=0;	


  
	P3M0 |= (1<<3);
	P3M1 &= ~(1<<3);
		
	P3M0 |= (1<<2);
	P3M1 &= ~(1<<2);

	P3M0 |= (1<<1);
	P3M1 &= ~(1<<1);	 


    	ts_event.x1=0;
		ts_event.y1=0;
		ts_event.x2=0;
		ts_event.y2=0;
		ts_event.x3=0;
		ts_event.y3=0;
		ts_event.x4=0;
		ts_event.y4=0;
		ts_event.x5=0;
		ts_event.y5=0;



	/*	RESET=0;
		INT=0;
		Delay1ms(30);
 		INT=1;
		Delay1ms(5);
		RESET=1;;
		Delay1ms(20);
		ACC=INT;
		ACC=INT;
 		Delay1ms(200);	 */


		P3M0 |= (1<<2);
     	P3M1 &= ~(1<<2);
 		RESET=0;						   
		CINT=0;
		delay_ms(20);
 		RESET=1;
		delay_ms(50);

		P3M0 &= ~(1<<2);
	    P3M1 |= (1<<2);

		ACC=CINT;
 		ACC=CINT;
 		delay_ms(100);

   	GT911_Send_Cfg((uchar*)GTP_CFG_DATA,sizeof(GTP_CFG_DATA));

	GT911_RD_Reg(GTP_REG_CONFIG_DATA,ss,sizeof(GTP_CFG_DATA));
	   	if((ss[2]==0x03)&&(ss[3]==0x58))return 1;
/*		else{

		P3M0 |= (1<<2);
	P3M1 &= ~(1<<2);


		  RESET=0;						   
		INT=0;
		delay_ms(20);
 		RESET=1;
		delay_ms(50);
		P3M0 &= ~(1<<2);
	    P3M1 |= (1<<2);

		ACC=INT;
 		ACC=INT;
 		delay_ms(100);

    	GT911_Send_Cfg((uchar*)GTP_CFG_DATA,sizeof(GTP_CFG_DATA));
		GT911_RD_Reg(GTP_REG_CONFIG_DATA,ss,sizeof(GTP_CFG_DATA));
		if((ss[2]==0x03)&&(ss[3]==0x58))return 1;
		}
			   */
	   	
		return 0;

}



void TPTEST(void)
{
	uchar ss[4];  uchar re=0;  	
   	Touch_State=Key_Up;



	Main_Image_Start_Address(0);				
	Main_Image_Width(LCD_Width);							
	Main_Window_Start_XY(0,0);

	Canvas_Image_Start_address(0);//Layer 1
	Canvas_image_width(LCD_Width);//
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width,LCD_Height);
	Start_Square_Fill();

 ///////////////////////////Square
	Foreground_color_65k(Red);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square();
	delay_ms(1);

  	 CGROM_Select_Internal_CGROM();
 	Internal_CGROM_Select_ISOIEC8859_1();
 	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);
 	Foreground_color_65k(White);
	Background_color_65k(Black);

  	re=TOUCH_Init();
	if(re==1)
	{Goto_Text_XY(2,2);Show_String("send CFG OK");}
	 else  {Goto_Text_XY(2,2);Show_String("send CFG NOK");}


					Goto_Text_XY(40,200);	
					Show_String("Capacitive touch screen test");
					Goto_Text_XY(LCD_Width-61,LCD_Height-25);
					Show_String("Clear");   
					Goto_Text_XY(5,LCD_Height-25);
					Show_String("Exit");


	while(next)
	{
	    GT911_RD_Reg(GTP_READ_COOR_ADDR,ss,1);
	    if(ss[0]&0x80)
//	 if(Touch_State==Key_Down)        //The touch screen is pressed
			{
					GT911_read_data();
					
				
				if ((ts_event.x1<85) &&(ts_event.y1>560))return;// flag=0; 
            	if ((ts_event.x1>710) &&(ts_event.y1>560))
              	{ 
				  	Foreground_color_65k(Black);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width,LCD_Height);
					Start_Square_Fill();

				 	Foreground_color_65k(Red);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width,LCD_Height-1);
					Start_Square();
					Foreground_color_65k(White);
					Background_color_65k(Black);
					
					Goto_Text_XY(40,200);	
					Show_String("Capacitive touch screen test");
					Goto_Text_XY(LCD_Width-61,LCD_Height-25);
					Show_String("Clear");   
					Goto_Text_XY(5,LCD_Height-25);
					Show_String("Exit");
              	} 



					inttostr(ts_event.x1,ss);	

					Foreground_color_65k(White);
					Background_color_65k(Black);

					Goto_Text_XY(100,60);
					Show_String("X = ");	

					Text_Mode();
					LCD_CmdWrite(0x04);							
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]);	 

					inttostr(ts_event.y1,ss);
					Goto_Text_XY(100,140);   //Set the display position
				  	LCD_CmdWrite(0x02);
					Show_String("Y = ");	
					Text_Mode();
					LCD_CmdWrite(0x04);	
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]);


					if(ts_event.touch_point == 1)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);}

					if(ts_event.touch_point == 2)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);}
													 	
					if(ts_event.touch_point == 3)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);}

					if(ts_event.touch_point == 4)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);
													 Draw_Circle_Fill(Cyan,ts_event.x4,ts_event.y4,2);}	

					if(ts_event.touch_point == 5)	{Draw_Circle_Fill(Red,ts_event.x1,ts_event.y1,2);
													 Draw_Circle_Fill(Green,ts_event.x2,ts_event.y2,2);
													 Draw_Circle_Fill(Blue,ts_event.x3,ts_event.y3,2);
													 Draw_Circle_Fill(Cyan,ts_event.x4,ts_event.y4,2);
													 Draw_Circle_Fill(Magenta,ts_event.x5,ts_event.y5,2);}

			
			}	



    }
   	
  
      
}





#endif






#if RTP		  // Resistive touch screen

unsigned int x[1]=0; 		//Current coordinates
unsigned int y[1]=0;								
unsigned char touchtype=0;				
//The default is touchtype=0
unsigned char CMD_RDX=0XD0;
unsigned char CMD_RDY=0X90;

	 			    					   
// SPI write data
// Write data to the touchscreen IC 1byte
// num: data to be written
void TP_Write_Byte(unsigned char num)    
{  
	unsigned char count=0;   
	for(count=0;count<8;count++)  
	{ 	  
		if(num&0x80)TDIN=1;  
		else TDIN=0;   
		num<<=1;    
		TCLK=0; 
		_nop_();_nop_();_nop_();_nop_();
		TCLK=1;		//Rising Edge 	        
	}		 			    
} 		 
// SPI read data
// Read adc value from the touch screen IC
// CMD: Directive
// Returns: read data	   
unsigned int TP_Read_AD(unsigned char CMD)	  
{ 	 
	unsigned char count=0; 	  
	unsigned int Num=0; 
	TCLK=0;		//Pulling low the clock	 
	TDIN=0; 	//Pulling low the data line
	TCS=0; 		//Select the touchscreen IC
	_nop_();
	TP_Write_Byte(CMD);//Send command word

	_nop_();_nop_();_nop_();_nop_();
	TCLK=1; 
	_nop_();_nop_();_nop_();_nop_();     	      	   
	TCLK=0;		//To a clock, clear BUSY
	_nop_();_nop_();_nop_();_nop_();
     	     	    
	for(count=0;count<12;count++)//only the high 12
	{ 				  
		Num<<=1; 	 
		TCLK=1;		    	    
		_nop_();_nop_();_nop_();_nop_();  
 		TCLK=0;
 		if(DOUT)Num++; 		 
	}  	
	TCS=1;		 
	return(Num);   
}
// Reads a coordinate value (x or y)
// Sequential read READ_TIMES secondary data, these data in ascending order,
// Then remove the minimum and maximum number LOST_VAL, averaging
// xy: Directive (CMD_RDX / CMD_RDY)
// Returns: read data
#define READ_TIMES 10 	//Reads TIMES
#define LOST_VAL 2	  	//Discard value
unsigned int TP_Read_XOY(unsigned char xy)
{	unsigned int i, j;
	unsigned int buf[READ_TIMES];
	unsigned int sum=0;
	unsigned int temp;
	for(i=0;i<READ_TIMES;i++)buf[i]=TP_Read_AD(xy);		 		    
	for(i=0;i<READ_TIMES-1; i++)//Sequence
	{
		for(j=i+1;j<READ_TIMES;j++)
		{
			if(buf[i]>buf[j])//Ascending
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}	  
	sum=0;
	for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
	temp=sum/(READ_TIMES-2*LOST_VAL);
	return temp;   
} 
// Read the x, y coordinates
// Minimum of not less than 100.
// x, y: read coordinates
// Return value: 0, failed; a successful.
unsigned char TP_Read_XY(unsigned int *x,unsigned int *y)
{
	unsigned int xtemp,ytemp;			 	 		  
	xtemp=TP_Read_XOY(CMD_RDX);
	ytemp=TP_Read_XOY(CMD_RDY);	  												   
	//if(xtemp<100||ytemp<100)return 0;//Reading failure
	*x=xtemp;
	*y=ytemp;
	return 1;//Reading success
}
// 2 consecutive reads touchscreen IC, and this deviation should not exceed twice
// ERR_RANGE, to meet the conditions, then that reading is correct, otherwise erroneous readings.
// This function can greatly improve the accuracy of
// x, y: read coordinates
// Return value: 0, failed; a successful.
#define ERR_RANGE 100 //error range
unsigned char TP_Read_XY2(unsigned int *x,unsigned int *y) 
{
	unsigned int x1,y1;
 	unsigned int x2,y2;
 	unsigned char flag;    
    flag=TP_Read_XY(&x1,&y1);   
    if(flag==0)return(0);
    flag=TP_Read_XY(&x2,&y2);	   
    if(flag==0)return(0);   
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))&&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))//Twice before and after sampling within + -100
	
    {
        *x=(x1+x2)/2;
        *y=(y1+y2)/2;
        return 1;
    }else return 0;	  
}  




void TPTEST(void)
{  uchar exit=0; uint LX,LY;
	unsigned char ss[6];	


	Main_Image_Start_Address(0);				
	Main_Image_Width(LCD_Width);							
	Main_Window_Start_XY(0,0);

	Canvas_Image_Start_address(0);//Layer 1
	Canvas_image_width(LCD_Width);//
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width,LCD_Height);
	Start_Square_Fill();

 ///////////////////////////Square
	Foreground_color_65k(Red);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square();
	delay_ms(1);


	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);

	while(next)
	{Foreground_color_65k(White);
	Background_color_65k(Black);

	Goto_Text_XY(40,200);	
	Show_String("Resistive touch screen test");

	Goto_Text_XY(LCD_Width-88,LCD_Height-40);

	Show_String("Clear");   
	Goto_Text_XY(15,LCD_Height-40);
	Show_String("Exit");
					 
		if(PEN==0 )			//Touch screen is pressed

		{	
		 								 	 		  
				TP_Read_XY2(&x[0],&y[0]);
				LX=((x[0]-100)*10/49);
				LY=((y[0]-200)*10/63);

	   
			 	//LX=((x[0]-100)*10/48);
				//LY=((y[0]-200)*10/77);

				if ((LX<85) &&(LY>560))return;// flag=0;
  
            	if ((LX>710) &&(LY>560))
              	{ 
				  	Foreground_color_65k(Black);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width,LCD_Height);
					Start_Square_Fill();

				 	Foreground_color_65k(Red);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_Width-1,LCD_Height-1);
					Start_Square();
					Foreground_color_65k(White);
					Background_color_65k(Black);
					CGROM_Select_Internal_CGROM();

					Goto_Text_XY(40,200);
					Show_String("Resistive touch screen test");
					Goto_Text_XY(LCD_Width-88,LCD_Height-40);

					Show_String("Clear");   
					Goto_Text_XY(15,LCD_Height-40);
					Show_String("Exit");
              	} 
		 	
			
				Draw_Circle_Fill(Red,LX,LY,2);

				ss[0]=LX/10000+48;
				ss[1]=(LX/1000)-((LX/10000)*10)+48;
				ss[2]=(LX/100)-((LX/1000)*10)+48;
				ss[3]=(LX/10)-((LX/100)*10)+48;
				ss[4]=LX-((LX/10)*10)+48;
				ss[5]=0;
	
				Foreground_color_65k(White);
				Background_color_65k(Black);


			Goto_Text_XY(10,305);
			Show_String("X:");
 			Goto_Text_XY(35,305);
			Show_String(ss);
	




				ss[0]=LY/10000+48;
				ss[1]=(LY/1000)-((LY/10000)*10)+48;
				ss[2]=(LY/100)-((LY/1000)*10)+48;
				ss[3]=(LY/10)-((LY/100)*10)+48;
				ss[4]=LY-((LY/10)*10)+48;
				ss[5]=0;
	
				Foreground_color_65k(White);
				Background_color_65k(Black);

			Goto_Text_XY(130,305);
			Show_String("Y:");
 			Goto_Text_XY(165,305);
			Show_String(ss);





			
		}
		else delay_ms(10);	//NO Touch	    
	
	}



}



#endif






